@use crate::templates::base_html;
@use crate::reverse_dependencies::CratePageRevDeps;
@use crate::templates::rev_dep_row_html;
@use crate::Urler;
@use kitchen_sink::DependencyKind;

@(url: &Urler, p: &CratePageRevDeps<'_>)

@:base_html(&p.page(), {
  <header id="rev-deps" @if p.ver.is_yanked() {class="yanked"} else {@if p.ver.is_nightly() {class="nightly"}}>
    <div class="inner-col">
    <div class="breadcrumbs">
      <a href="/"><span>Lib</span>.rs</a> ›
    <h1>
     <a href="@url.krate(p.ver)" rel="up">@p.ver.capitalized_name()</a>
    </h1>
     › Reverse dependencies
    </div>
    </div>
  </header>
  <main>
    <div class="inner-col">
      @if let Some((g, years)) = p.changes_graph() {
        <div class="active-users @if g.len() >= 48 {big}"><table>
          <caption><strong>Active</strong> direct dependers over time: total, gained/lost</caption>
          <tr class=total>
            @for ch in &g {
              <td>@if !ch.label_inside {<span>@ch.running_total</span>}
                @if ch.running_total > 0 {<div class="@if ch.added > ch.removed {gaining} @if ch.added < ch.removed {losing}"
                    style="width: @(ch.width)px; height: @(ch.running_totals_height)px">@if ch.label_inside {<span>@ch.running_total</span>}</div>}
              </td>
            }
          </tr>
          <!-- <tr class=total>
            @for ch in &g {
              <td>@if !ch.users_label_inside {<span>@ch.users_total</span>}
                @if ch.users_total > 0 {<div style="width: @(ch.width)px; height: @(ch.users_totals_height)px">@if ch.users_label_inside {<span>@ch.users_total</span>}</div>}
              </td>
            }
          </tr> -->
          <tr>
            @for (year, colspan) in years {
              <th colspan=@colspan @if colspan < 8 {class="partial"}>@if colspan > 2 {@year}</th>
            }
          </tr>
          <tr class=added>
            @for ch in &g {
              <td>@if ch.added_height > 0 {<div style="width: @(ch.width)px; height: @(ch.added_height-1)px"></div>}</td>
            }
          </tr>
          <tr class=removed>
            @for ch in &g {
              <td>@if ch.removed_height > 0 {<div style="width: @(ch.width)px; height: @(ch.removed_height-1)px"></div>}</td>
            }
          </tr>
        </table></div>
      }

      @if let Some(stats) = p.stats {
        <p>
          @if stats.counters.runtime.all() > 0 {
            <a href="@url.krate(p.ver)" rel="up">@p.ver.capitalized_name()</a> is used at run time in <b>@p.format_number(stats.counters.runtime.all())</b> crate@if stats.counters.runtime.all() != 1 {s}@if stats.counters.runtime.opt > 0 { (of which @p.format_number(stats.counters.runtime.opt) optionally)}.

            @if (stats.counters.runtime.all()*8) > (u32::from(stats.counters.direct.runtime)*9+1) {
              It is a <em>direct</em> run-time dependency in @p.format_number(stats.counters.direct.runtime) crate@if stats.counters.direct.runtime != 1 {s}.
            }
          }

          @if stats.counters.build.all() > 0 {
            It's used at build time in <b>@p.format_number(stats.counters.build.all())</b> crate@if stats.counters.build.all() != 1 {s}@if stats.counters.build.all() > u32::from(stats.counters.direct.build) {
              (@if stats.counters.build.opt > 0 {of which @p.format_number(stats.counters.build.opt) optionally, }@if stats.counters.direct.build > 0 {@p.format_number(stats.counters.direct.build) directly})}.
          }

          @if stats.counters.dev > 0 {
            It's used only as a dev dependency in @p.format_number(stats.counters.dev) crate@if stats.counters.dev != 1 {s}@if stats.counters.dev > stats.counters.direct.dev && stats.counters.direct.dev > 0 {
            (of which @p.format_number(stats.counters.direct.dev) directly)}.
          }
        </p>

        @if stats.versions.len() > 1 {
          <table class="version-pop">
            <thead><th>Number of dependers</th>
              <th>
                @if let Some(verurl) = url.all_versions(p.ver.origin()) {
                  <a href="@verurl">@p.ver.capitalized_name() version</a>
                } else {
                  @p.ver.capitalized_name() version
                }
              </th>
              <th>Downloads/month</th></thead>
            @for x in p.version_breakdown() {
              <tr>
                <td class="rv">@if x.num == 0 || x.perc <= x.num_width {@x.num_str} @if x.num > 0 {<span style="width:@x.perc%">@if x.perc > x.num_width {@x.num_str}</span>}</td>
                <th @if let Some((_,_,n)) = x.patch_merged {title="@n versions counted together"}>@if let Some((before,after,_)) = &x.patch_merged {@before<var>@after</var>}
                  else {@x.ver}</th>
                <td class="dl">
                  @if x.dl.num > 0 {
                    <span style="width:@x.dl.perc%">@if x.dl.perc > x.dl.num_width {@x.dl.str.0<b>@x.dl.str.1</b>}</span>
                  }
                  @if x.dl.num == 0 || x.dl.perc <= x.dl.num_width {@x.dl.str.0<b>@x.dl.str.1</b>}
                </td>
              </tr>
            }
          </table>
        }
      }

      @if !p.deps.is_empty() {
        <table class="reverse-deps @if !p.has_download_columns {no-dl-columns}">
          <thead>
              <tr><th colspan="3">Depender
                @if p.has_download_columns {<small title="the second column is a sum direct dependencies (normal and dev)">(with downloads and own rev deps)</small>}
              </th><th colspan="2" title="tooltips include features of @p.ver.short_name() that were explicitly enabled">@p.ver.capitalized_name() version</th></tr>
          </thead>
          @for r in p.deps.iter().filter(|r| r.kind != DependencyKind::Dev).chain(p.deps.iter().filter(|r| r.kind == DependencyKind::Dev)) {
            @:rev_dep_row_html(url, p, r)
          }
        </table>
      } else {
        <p>This crate isn't used by any other public crates. <a href="@url.krate(p.ver)" rel="up">Go back to @p.ver.capitalized_name()</a>.</p>
      }
    </div>
  </main>

  <footer>
    <div class="inner-col">
        <p><a href="/revdeps">How this data is computed</a>. Back to <a href="@url.krate(p.ver)" rel="up">@p.ver.capitalized_name()</a>.</p>
    </div>
  </footer>
})
